<?
/*
* GuildRelay.php - Relay chat between guildchannels.
*
* BeBot - An Anarchy Online Chat Automaton
* Copyright (C) 2004 Jonas Jax
*
* Developed by Blondengy (RK1)
* Special thanks goes out to Khalem (RK1) for his support.
*
* File last changed at $LastChangedDate: 2005-12-13 03:46:11 +0100 (Tue, 13 Dec 2005) $
* Revision: $Id: GuildRelay_GUILD.php 45 2005-12-13 02:46:11Z shadowmaster $
*/

/*
Add a "_" at the beginning of the file (_GuildRelay.php) if you do not want it to be loaded.
*/


/*
Prepare MySQL database
*/
$db->query("CREATE TABLE IF NOT EXISTS " . $bot -> get_tablename("relay_bots") . "
        (botname VARCHAR(20) PRIMARY KEY,
	guildname VARCHAR(30),
	bottype VARCHAR(5) DEFAULT 'BeBot',
	verified INT(1) DEFAULT '0')");

//$db->query("ALTER TABLE " . $bot -> get_tablename("relay_bots") . " ADD COLUMN bottype VARCHAR(5) DEFAULT 'BeBot' AFTER `guildname`");

$guildrelay = new GuildRelay($bot);

$commands["tell"]["gcr"] = &$guildrelay;
$commands["tell"]["gcrq"] = &$guildrelay;
$commands["tell"]["connect"] = $guildrelay;
$commands["tell"]["disconnect"] = $guildrelay;
$commands["tell"]["guildrelay"] = &$guildrelay;
$commands["gc"]["guildrelay"] = &$guildrelay;
$commands["gc"]["connect"] = $guildrelay;
$commands["gc"]["disconnect"] = $guildrelay;
$commands["connect"][] = &$guildrelay;
$commands["relay"]["guild"] = &$guildrelay;



/*
The Class itself...
*/
class GuildRelay
{
	var $bot;
	var $table;


	/*
	Constructor:
	Hands over a referance to the "Bot" class.
	*/
	function GuildRelay (&$bot)
	{
		$this -> bot = &$bot;
		$this -> table = $this -> bot -> get_tablename("relay_bots");
	}



	/*
	This gets called on a tell with the command
	*/
	function tell($name, $msg)
	{
		/* Incomming relayed chat */
		if (preg_match("/^!gcr (.+)$/im", $msg, $info))
		{
			$bot = $this -> bot -> db -> select("SELECT * FROM " . $this -> table
				. " WHERE botname = '" . $name . "'");
			if (!empty($bot))
			{
				$this -> bot -> send_gc($info[1], 0, false);
				$this -> bot -> send_pgroup($info[1]);
			}
		}
		else if (preg_match("/^" . $this -> bot -> commpre . "guildrelay (.+)$/i", $msg, $info))
		{
			if (strtolower($info[1]) == "off")
			{
				$this -> stop_relay(true);
			}
			else if (strtolower($info[1]) == "on")
			{
				$this -> start_relay(true);
			}
		}
		/* Incomming relay request or verification */
		else if (preg_match("/^\!gcrq (.+)/is", $msg, $info))
		{
			$this -> connect_request($name, $info[1]);
		}
		/* Player requested connection */
		else if (preg_match("/^" . $this -> bot -> commpre . "connect (.+)$/i", $msg, $info))
		{
			$this -> do_connect($name, $info[1]);
		}
		else if (preg_match("/^" . $this -> bot -> commpre . "disconnect (.+)$/i", $msg, $info))
		{
			$this -> disconnect($name, $info[1]);
		}
	}

	function relay($name, $msg)
	{
		/* Incomming relayed chat */
		if (preg_match("/^transmit (.+)$/im", $msg, $info))
		{
			$bot = $this -> bot -> db -> select("SELECT * FROM " . $this -> table
				. " WHERE botname = '" . $name . "'");
			if (!empty($bot))
			{
				$this -> bot -> send_gc($info[1], 0, false);
				$this -> bot -> send_pgroup($info[1]);
			}
		}
		/* Incomming relay request or verification */
		else if (preg_match("/^ignsend (.+)/is", $msg, $info))
		{
			$this -> ign_connect_request($name, $info[1]);
		}
		else
		{
			$this -> bot -> log("RELAY", "INC", "Relayed from $name: $msg  --- sending to tell()");
			$this -> tell($name, $msg);
		}
	}



	/*
	This gets called on a msg in the guildchat with the command
	*/
	function gc($name, $msg)
	{
		if (preg_match("/^" . $this -> bot -> commpre . "guildrelay (.+)$/i", $msg, $info))
		{
			if (strtolower($info[1]) == "off")
			{
				$this -> stop_relay(true);
			}
			else if (strtolower($info[1]) == "on")
			{
				$this -> start_relay(true);
			}
		}
		else if (preg_match("/^" . $this -> bot -> commpre . "connect (.+)$/i", $msg, $info))
		{
			$this -> do_connect('gc', $info[1]);
		}
		else if (preg_match("/^" . $this -> bot -> commpre . "disconnect (.+)$/i", $msg, $info))
		{
			$this -> disconnect('gc', $info[1]);
		}
	}



	/*
	This gets called on a msg in the group
	*/
	function gmsg($name, $group, $msg)
	{
		if (strtolower($name) != strtolower($this -> bot -> botname) &&
		    !isset($this -> bot -> other_bots[$name]))
		{
			$this -> bot -> send_relay("[" . $this -> bot -> guildname . "] " . $name . ": " . $msg);
		}
	}



	/*
	This gets called on a msg in the privgroup without a command
	*/
	function privgroup($name, $msg)
	{
		if (strtolower($name) != strtolower($this -> bot -> botname) &&
		    !isset($this -> bot -> other_bots[$name]))
		{
			$this -> bot -> send_relay("[" . $this -> bot -> guildname . " Guest] " . $name . ": " . $msg);
		}
	}



	/*
	This gets called on bot startup
	*/
	function connect()
	{
		if ($this -> bot -> guild_relay == true)
		{
			$this -> start_relay();
			$guilds = $this -> bot -> db -> select("SELECT guildname FROM " . $this -> table
				. " WHERE verified = '1'");
			if (!empty($guilds))
			{
				$relays = "";
				foreach ($guilds as $guild)
				{
					$relays .= $guild[0] . ", ";
				}
				$guilds = substr ($relays, 0, -2);
				$this -> bot -> db -> query("INSERT INTO " . $this -> bot -> get_tablename("auto_msg")
					. " (type, towho, msg) VALUES ('gc', '', "
					. "'Relaying guildchat with <font color=#ffff00>" . $guilds . "</font>.')");
			}
		}
	}


	function connect_request($name, $msg)
	{
		if (preg_match("/^connect$/i", $msg))
		{
			$who = $this -> bot -> whois -> lookup($name);
			$this -> bot -> db -> query("INSERT IGNORE INTO " . $this -> table
				. " (botname, guildname, bottype, verified) VALUES "
				. "('" . $who['nick'] . "', '" . $who['org'] . "', 'BeBot', '0')");
			$this -> bot -> send_gc($who['org'] . " has requested guild chat connection. Do <font color=#DDDDFF>/tell <botname> <pre>connect " . $who['nick'] . "</font> to establish connection.");
		}
		else if (preg_match("/^verified$/i", $msg))
		{
			$who = $this -> bot -> whois -> lookup($name);
			$this -> bot -> db -> query("UPDATE " . $this -> table
				. " SET verified = '1' WHERE botname = '" . $who['nick'] . "'");
			$this -> start_relay();
			$this -> bot -> guild_relay = true;
			$this -> bot -> send_gc("Relaying guildchat to <font color=#ffff00>" . $who['org'] . "</font>.");
		}
		else if (preg_match("/^disconnect$/i", $msg))
		{
			$who = $this -> bot -> whois -> lookup($name);
			$this -> bot -> db -> query("DELETE FROM " . $this -> table
				. " WHERE botname = '" . $name . "'");
			$this -> bot -> send_gc("<font color=#ffff00>"
				. $who['org'] . "</font> guildchat relay disconnected.");
		}
		else
		{
			$this -> bot -> log("RELAY", "BEBOT", "Unknown request " . $msg);
			print_r($info);
		}
	}


	function ign_connect_request($name, $msg)
	{
		if (preg_match("/^on (.+)$/i", $msg))
		{
			$who = $this -> bot -> whois -> lookup($name);
			$this -> bot -> db -> query("INSERT IGNORE INTO " . $this -> table
				. " (botname, guildname, bottype, verified) VALUES "
				. "('" . $who['nick'] . "', '" . $who['org'] . "', 'IGN', '0')");
			$this -> bot -> send_gc($who['org'] . " has requested guild chat connection. Do <font color=#DDDDFF>/tell <botname> <pre>connect " . $who['nick'] . "</font> to establish connection.");
		}
		else if (preg_match("/^ok (.+)$/i", $msg))
		{
			$who = $this -> bot -> whois -> lookup($name);
			$this -> bot -> db -> query("UPDATE " . $this -> table
				. " SET verified = '1' WHERE botname = '" . $who['nick'] . "'");
			$this -> start_relay();
			$this -> bot -> guild_relay = true;
			$this -> bot -> send_gc("Relaying guildchat to <font color=#ffff00>" . $who['org'] . "</font>.");
		}
		else if (preg_match("/^ld$ (.+)/i", $msg))
		{
			$who = $this -> bot -> whois -> lookup($name);
			$this -> bot -> db -> query("DELETE FROM " . $this -> table
				. " WHERE botname = '" . $name . "'");
			$this -> bot -> send_gc("<font color=#ffff00>"
				. $who['org'] . "</font> guildchat relay disconnected.");
		}
		else
		{
			$this -> bot -> log("RELAY", "IGN", "Unknown request " . $msg);
			print_r($info);
		}
	}

	function do_connect($name, $msg)
	{
		if (preg_match("/^ign (.+)$/i", $msg, $info))
		{
			$bottype = 'IGN';
			$botname = $info[1];
			$command = 'ignsend on ' . $this -> bot -> guildname;
		}
		else
		{
			$bottype = 'BeBot';
			$botname = $msg;
			$command = '!gcrq connect';
		}
		$who = $this -> bot -> whois -> lookup($botname);
		if (!empty($who))
		{
			$reply = "";
			$relay = $this -> bot -> db -> select("SELECT botname,guildname,bottype,verified FROM "
				. $this -> table . " WHERE botname = '" . $who['nick'] . "'");
			if (!empty($relay))
			{
				if ($relay[0][3] == 1)
				{
					$reply = "Connection to " . $relay[0][1] . " is already established.";
				}
				else
				{
					if ($relay[0][2] == 'BeBot')
					{
						$this -> bot -> send_tell($relay[0][0], "!gcrq verified", 0, false);
					}
					else if ($relay[0][2] == 'IGN')
					{
						$this -> bot -> send_tell($relay[0][0], "ignsend ok " . $this -> bot -> guildname, 0, false);
					}
					$this -> bot -> db -> query("UPDATE " . $this -> table
						. " SET verified = '1' WHERE botname = '" . $who['nick'] . "'");
					$reply = "Relay connection verification sent to <font color=#ffff00>"
						. $relay[0][1] . "</font>.";
				}
			}
			else
			{
				$this -> bot -> db -> query("INSERT INTO " . $this -> table
					. " (botname, guildname, bottype, verified) VALUES "
					. "('" . $who['nick'] . "', '" . $who['org'] . "', '" . $bottype . "', '0')");
				$this -> bot -> send_tell($who['nick'], $command, 0, false);
				$reply = "Relay connection request sent to <font color=#ffff00>"
					. $who['org'] . "</font>.";
			}

			if ($name == 'gc')
			{
				$this -> bot -> send_gc($reply);
			}
			else
			{
				$this -> bot -> send_tell($name, $reply);
			}
		}
		else
		{
			$this -> bot ->send_tell($name, "Botname " . $botname . " does not exist.");
		}
	}


	function disconnect($name, $msg)
	{
		$who = $this -> bot -> whois -> lookup($msg);
		if (!empty($who))
		{
			$result = $this -> bot -> db -> select("SELECT bottype FROM " . $this -> table
				. " WHERE botname = '" . $who['nick'] . "'");
			$this -> bot -> db -> query("DELETE FROM " . $this -> table
				. " WHERE botname = '" . $who['nick'] . "'");
			if( $result[0][0] == 'BeBot' )
			{
				$this -> bot -> send_tell($who['nick'], "!gcrq disconnect", 0, false);
			}
			else if( $result[0][0] == 'IGN' )
			{
				$this -> bot -> send_tell($who['nick'], "ignsend ld", 0, false);
			}
			$this -> bot -> send_tell($name, "Relay disconnection request sent to <font color=#ffff00>"
				. $who['org'] . "</font>.");
		}
		else
		{
			$this -> bot ->send_tell($name, "Botname " . $msg . " does not exist.");
		}
	}


	function start_relay($silent = false)
	{
		$this -> bot -> commands["gmsg"][$this -> bot -> guildname]["guildrelay"] = &$this -> bot -> commands["tell"]["gcr"];
		$this -> bot -> commands["privgroup"]["guildrelay"] = &$this -> bot -> commands["tell"]["gcr"];
		$this -> bot -> guild_relay = true;
		if (!$silent)
		{
			$this -> bot -> send_gc("<font color=#ffff00>Guildrelay</font> has been turned <font color=#ffff00>on</font>.");
		}
	}


	function stop_relay($silent = false)
	{
		unset($this -> bot -> commands["gmsg"][$this -> bot -> guildname]["guildrelay"]);
		unset($this -> bot -> commands["privgroup"]["guildrelay"]);
		$this -> bot -> guild_relay = false;
		if (!$silent)
		{
			$this -> bot -> send_gc("<font color=#ffff00>Guildrelay</font> has been turned <font color=#ffff00>off</font>.");
		}
	}
}
?>
